︠34f85baa-3261-4388-8786-2fce0aa4d5fdi︠
%html
<h2 style="color:blue">
    Bard - Sage - Area Function Demo
</h2>
︡2be4e556-ad3e-4fba-9f76-8bee26691dc1︡{"html":"<h2 style=\"color:blue\">\n    Bard - Sage - Area Function Demo\n</h2>\n"}︡
︠de8376e9-c554-41cd-8500-73b2ad226120︠
%html

<ul>
    <li>Put the cursor in the code below, and then click on Run (the green square with the triangle in the middle of the menu above).</li>
    <li>You can change the function $f(x)$, the points $a$ and $b$, the $x$-interval and $y$-interval, and the aspect ratio.</li>
    <li>Click on different values of $h$, using either $+h$ or $-h$, and see what happens to graph of the secant line and to the difference quotient.</li>
</ul>

︡c78eff2c-4679-4c76-9610-8ab7f4221736︡{"html":"\n<ul>\n    <li>Put the cursor in the code below, and then click on Run (the green square with the triangle in the middle of the menu above).</li>\n    <li>You can change the function $f(x)$, the points $a$ and $b$, and the $x$-interval and $y$-interval.</li>\n</ul>\n\n"}︡
︠d94c799c-6ea1-43d1-a812-11ab152876b9s︠
x, y, z, t = var('x, y, z, t')
@interact
def _(
    f = input_box(default=sin(x)),
    a = slider(0, 10, default=0.1, label="a"),
    xinterval = range_slider(-10, 10, 1, default=(-2, 10), label="x-interval"),
    yinterval = range_slider(-50, 50, 1, default=(-2, 2), label="y-interval"),
    aspect_ratio = ("Aspect Ratio 1", True),
    ):
        x_min, x_max = map(QQ, xinterval)
        y_min, y_max = map(QQ, yinterval)

        aa = n(a)
        fa = n(f(a))
        derf = derivative(f,x)
        derfa = n(derf(a))
        tanf = derfa*(x - aa) + fa

        k = Piecewise([[(x_min,0),0],[(0,a),derf],[(a,x_max),0]])

        apr = (x_max - x_min)/(y_max - y_min)
        plf = plot(f, x_min, x_max, ymin = y_min, ymax = y_max)
        plk = plot(k, xmin = x_min, xmax = x_max, ymin = y_min, ymax = y_max)

        lna = line([(a, y_min),(a, y_max)], linestyle = "dashed", color = 'purple', alpha = 0.5)

        pldf = plot(tanf, x_min, x_max, ymin = y_min, ymax = y_max, color = "darkseagreen")
        apt = point((aa,fa), color = "darkgreen", size=40)

        html(r'''
        <div class="math">
        \begin{align*}
        f(x) &= %s \\\
        a &= %s \\\
        f'(a) &= %s
        \end{align*}
        </div>
        ''' % (latex(f), a, derfa))
        if aspect_ratio == True:
            show(plf + lna + pldf + apt, aspect_ratio=1, figsize=8)
            show(plk + lna, aspect_ratio=1, figsize=8)
        else:
            show(plf + lna + pldf + apt, aspect_ratio=apr, figsize=8)
            show(plk + lna, aspect_ratio=apr, figsize=8)
︡c394286d-b63e-4b41-ac1e-aac0f5fcbc47︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["a",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["aspect_ratio",12,null]],[["",12,null]]],"id":"6f1183c2-fde0-4870-9afd-aff5d01d57fb","controls":[{"control_type":"input-box","default":"sin(x)","label":"f","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"slider","default":5,"var":"a","width":null,"vals":["0.0","0.02","0.04","0.06","0.08","0.1","0.12","0.14","0.16","0.18","0.2","0.22","0.24","0.26","0.28","0.3","0.32","0.34","0.36","0.38","0.4","0.42","0.44","0.46","0.48","0.5","0.52","0.54","0.56","0.58","0.6","0.62","0.64","0.66","0.68","0.7","0.72","0.74","0.76","0.78","0.8","0.82","0.84","0.86","0.88","0.9","0.92","0.94","0.96","0.98","1.0","1.02","1.04","1.06","1.08","1.1","1.12","1.14","1.16","1.18","1.2","1.22","1.24","1.26","1.28","1.3","1.32","1.34","1.36","1.38","1.4","1.42","1.44","1.46","1.48","1.5","1.52","1.54","1.56","1.58","1.6","1.62","1.64","1.66","1.68","1.7","1.72","1.74","1.76","1.78","1.8","1.82","1.84","1.86","1.88","1.9","1.92","1.94","1.96","1.98","2.0","2.02","2.04","2.06","2.08","2.1","2.12","2.14","2.16","2.18","2.2","2.22","2.24","2.26","2.28","2.3","2.32","2.34","2.36","2.38","2.4","2.42","2.44","2.46","2.48","2.5","2.52","2.54","2.56","2.58","2.6","2.62","2.64","2.66","2.68","2.7","2.72","2.74","2.76","2.78","2.8","2.82","2.84","2.86","2.88","2.9","2.92","2.94","2.96","2.98","3.0","3.02","3.04","3.06","3.08","3.1","3.12","3.14","3.16","3.18","3.2","3.22","3.24","3.26","3.28","3.3","3.32","3.34","3.36","3.38","3.4","3.42","3.44","3.46","3.48","3.5","3.52","3.54","3.56","3.58","3.6","3.62","3.64","3.66","3.68","3.7","3.72","3.74","3.76","3.78","3.8","3.82","3.84","3.86","3.88","3.9","3.92","3.94","3.96","3.98","4.0","4.02","4.04","4.06","4.08","4.1","4.12","4.14","4.16","4.18","4.2","4.22","4.24","4.26","4.28","4.3","4.32","4.34","4.36","4.38","4.4","4.42","4.44","4.46","4.48","4.5","4.52","4.54","4.56","4.58","4.6","4.62","4.64","4.66","4.68","4.7","4.72","4.74","4.76","4.78","4.8","4.82","4.84","4.86","4.88","4.9","4.92","4.94","4.96","4.98","5.0","5.02","5.04","5.06","5.08","5.1","5.12","5.14","5.16","5.18","5.2","5.22","5.24","5.26","5.28","5.3","5.32","5.34","5.36","5.38","5.4","5.42","5.44","5.46","5.48","5.5","5.52","5.54","5.56","5.58","5.6","5.62","5.64","5.66","5.68","5.7","5.72","5.74","5.76","5.78","5.8","5.82","5.84","5.86","5.88","5.9","5.92","5.94","5.96","5.98","6.0","6.02","6.04","6.06","6.08","6.1","6.12","6.14","6.16","6.18","6.2","6.22","6.24","6.26","6.28","6.3","6.32","6.34","6.36","6.38","6.4","6.42","6.44","6.46","6.48","6.5","6.52","6.54","6.56","6.58","6.6","6.62","6.64","6.66","6.68","6.7","6.72","6.74","6.76","6.78","6.8","6.82","6.84","6.86","6.88","6.9","6.92","6.94","6.96","6.98","7.0","7.02","7.04","7.06","7.08","7.1","7.12","7.14","7.16","7.18","7.2","7.22","7.24","7.26","7.28","7.3","7.32","7.34","7.36","7.38","7.4","7.42","7.44","7.46","7.48","7.5","7.52","7.54","7.56","7.58","7.6","7.62","7.64","7.66","7.68","7.7","7.72","7.74","7.76","7.78","7.8","7.82","7.84","7.86","7.88","7.9","7.92","7.94","7.96","7.98","8.0","8.02","8.04","8.06","8.08","8.1","8.12","8.14","8.16","8.18","8.2","8.22","8.24","8.26","8.28","8.3","8.32","8.34","8.36","8.38","8.4","8.42","8.44","8.46","8.48","8.5","8.52","8.54","8.56","8.58","8.6","8.62","8.64","8.66","8.68","8.7","8.72","8.74","8.76","8.78","8.8","8.82","8.84","8.86","8.88","8.9","8.92","8.94","8.96","8.98","9.0","9.02","9.04","9.06","9.08","9.1","9.12","9.14","9.16","9.18","9.2","9.22","9.24","9.26","9.28","9.3","9.32","9.34","9.36","9.38","9.4","9.42","9.44","9.46","9.48","9.5","9.52","9.54","9.56","9.58","9.6","9.62","9.64","9.66","9.68","9.7","9.72","9.74","9.76","9.78","9.8","9.82","9.84","9.86","9.88","9.9","9.92","9.94","9.96","9.98","10.0"],"animate":true,"label":"a","display_value":true},{"control_type":"range-slider","default":[8,20],"var":"xinterval","width":null,"vals":["-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10"],"animate":true,"label":"x-interval","display_value":true},{"control_type":"range-slider","default":[48,52],"var":"yinterval","width":null,"vals":["-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50"],"animate":true,"label":"y-interval","display_value":true},{"default":true,"var":"aspect_ratio","readonly":false,"control_type":"checkbox","label":"Aspect Ratio 1"}]}}︡
︠b5cd6c28-94d7-41a1-a0d6-3442ac85e098︠

︠f2cce214-e723-4a2b-92c0-2588a15aa810︠









