︠1345e1e0-242a-4305-bf17-3f49212f3240i︠
%html
<h2>
    Bard - Sage - Linear Transformations Demo
</h2>
︡90634c3f-1e6b-40ea-9923-ba27d4d39663︡{"html":"<h2>\n    Bard - Sage - Linear Transformations Demo\n</h2>\n"}︡
︠8c0e3f17-7c49-4a83-b5b7-4b4ea1e44f6di︠
%html

<ul>
    <li>Put the cursor in the code, and then click on Run.</li>
    <li>You can change the matrix $M$ by entering numbers in the grid, and then clicking on the green rectangle to the right of the grid.</li>
    <li>You can change the $x$-interval and $y$-interval of the graph by moving the sliders.</li>
    <li>You can see the effect of matrix multiplication by $M$ on the red rectangle by clicking on the "transformed" button; the transformed red rectangle will be blue.</li>
</ul>

︡383e1d72-89f1-4c8a-8e50-eca85385c1f7︡{"html":"\n<ul>\n    <li>Put the cursor in the code, and then click on Run.</li>\n    <li>You can change the matrix $M$ by entering numbers in the grid, and then clicking on the green rectangle to the right of the grid.</li>\n    <li>You can change the $x$-interval and $y$-interval of the graph by moving the sliders.</li>\n    <li>You can see the effect of matrix multiplication by $M$ on the red rectangle by clicking on the \"transformed\" button; the transformed red rectangle will be blue.</li>\n</ul>\n\n"}︡
︠8cd33e62-27f9-43aa-8c4f-2235fac330c4s︠
#Matrix input from The Gauss-Jordan method for inverting a matrix by Hristo Inouzhe

#Choose the initial two arrows
v1 = vector([2,0])
v2 = vector([0,1])


example = [[1 if k==j else 0 for k in range(2)] for j in range(2)]
example[0][-1] = 2
example[-1][0] = 0

@interact
def _(M=input_grid(2, 2, default = example, label='Matrix', to_value=matrix),
xinterval=range_slider(-50, 50, 1, default=(-10, 10), label="x-interval"),
yinterval=range_slider(-50, 50, 1, default=(-10, 10), label="y-interval"),
pm = selector(['original', 'transformed'], nrows=1, label="transform")
     ):

    x_min, x_max = map(QQ, xinterval)
    y_min, y_max = map(QQ, yinterval)

    w1 = M*v1
    w2 = M*v2

    html('$$M=%s$$'%latex(M))

    A1 = arrow2d([0,0],v1, rgbcolor='purple')
    A2 = arrow2d([0,0],v2,rgbcolor='green')
    A3 = arrow2d([0,0],w1, rgbcolor='purple')
    A4 = arrow2d([0,0],w2,rgbcolor='green')

    p1 = polygon([[0,0],v1,v1+v2,v2,[0,0]],rgbcolor='red', alpha=.5)
    p2 = polygon([[0,0],w1,w1+w2,w2,[0,0]],rgbcolor='blue', alpha=.5)
    if pm == 'original':
        show(p1 + A1 + A2, xmin=x_min, xmax=x_max, ymin=y_min, ymax=y_max, figsize=10)
    elif pm == 'transformed':
        show(p1 + p2 + A1 + A2 + A3 + A4, xmin=x_min, xmax=x_max, ymin=y_min, ymax=y_max, figsize=10)

︡d9c87a1c-3509-4351-b4c0-63ee63caf889︡{"interact":{"style":"None","flicker":false,"layout":[[["M",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["pm",12,null]],[["",12,null]]],"id":"921e34f2-3ca0-4abe-b2db-9c00da4a17b8","controls":[{"control_type":"input-grid","ncols":2,"default":[["1","2"],["0","1"]],"label":"Matrix","nrows":2,"width":5,"var":"M"},{"control_type":"range-slider","default":[40,60],"var":"xinterval","width":null,"vals":["-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50"],"animate":true,"label":"x-interval","display_value":true},{"control_type":"range-slider","default":[40,60],"var":"yinterval","width":null,"vals":["-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50"],"animate":true,"label":"y-interval","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["original","transformed"],"label":"transform","nrows":1,"width":null,"var":"pm"}]}}︡
︠b3b71cf1-db6f-4a7a-9a80-6ecb78b36a25︠









