︠9c62fd0c-f2d1-4ad7-b559-ba909c2e603di︠
︡3d753216-c773-43c3-802d-8b383d46b44f︡{"html":"<h2 style=\"color:blue\">\n    Bard - Sage - Matrix Operations Demo\n</h2>\n"}︡
︠8c0e3f17-7c49-4a83-b5b7-4b4ea1e44f6di︠
%html

<h3>
    Using the Sage Interface
</h3>

<ul>
    <li>Each activity starts after a gray horizontal line.</li>
    <li>Write the commands, then put the cursor in the code, and then click on Run.</li>
    <li>The output will appear after the commands, and a new gray line will appear, allowing for a new activity.</li>
    <li>If there is an error in the code, error messages will appear in red.</li>
    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>
    </ul>

︡d8883c4d-d143-4e0a-bd4a-9ba586cc28e9︡{"html":"\n<h3>\n    Using the Sage Interface\n</h3>\n\n<ul>\n    <li>Each activity starts after a gray horizontal line.</li>\n    <li>Write the commands, then put the cursor in the code, and then click on Run.</li>\n    <li>The output will appear after the commands, and a new gray line will appear, allowing for a new activity.</li>\n    <li>If there is an error in the code, error messages will appear in red.</li>\n    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>\n    </ul>\n\n"}︡
︠5e69c7b6-79ce-4afc-8724-9a5ad5d383a2︠
︡6ee7c2cc-d72f-43ab-827d-67fc2bf37c14︡{"html":"\n<h4>\n    Defining a matrix\n</h4>\n\n<ul>\n    <li>When a matrix is defined, the matrix is not automatically displayed.  To display the matrix, type its name on the line after the definition of the matrix.</li>\n    <li>The <tt>QQ</tt> in the following example tell Sage to think of the matrix as having rational number entries.  If you replace <tt>QQ</tt> with <tt>RR</tt>, as in the next example, the matrix will be displayed with decimal entries.</li>\n</ul>"}︡
︠712bc9c2-076b-4784-97d5-6d66fca8ddb9︠
M = Matrix(QQ,[[1,2,3],[3,2,1],[4,1,-1]])
M
︠8bad9ca5-5ff8-4314-a133-ea458aa32269︠
P = Matrix(RR,[[1,2,3],[3,2,1],[4,1,-1]])
P
︠115d184f-9de9-4349-983c-f5711be9e312is︠
%html

<h4>
    Adding two matrices
</h4>

<ul>
    <li>Addition of matrices is written <tt>A + B</tt> (which is also the way addition of numbers is written).</li>
    <li>It does not matter whether you put spaces around the plus sign.</li>
</ul>
︡ae3841b8-2ab2-467e-bc4d-535fa356c70c︡{"html":"\n<h4>\n    Adding two matrices\n</h4>\n\n<ul>\n    <li>Addition of matrices is written <tt>A + B</tt> (which is also the way addition of numbers is written).</li>\n    <li>It does not matter whether you put spaces around the plus sign.</li>\n</ul>\n"}︡
︠1e49ad69-cc54-4833-a956-a1f303f3d722s︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
B = Matrix(QQ,[[2,2,5],[-3,0,3],[1,-2,0]])
A + B
︠746117f4-4d19-493f-b3d4-e48d0f7d1b63is︠
%html

<h4>
    Scalar multiplying a matrix
</h4>

<ul>
    <li>Scalar multiplication of a matrix is written <tt>s*B</tt> (which is also the way multiplication of numbers is written).</li>
    <li>It does not matter whether you put spaces around the multiplication sign.</li>
    <li>Do not write <tt>sA</tt> or <tt>s A</tt>, because Sage will not understand it.</li>
</ul>
︡2d216e62-1e72-478d-baa7-8184eed0ad3e︡{"html":"\n<h4>\n    Scalar multiplying a matrix\n</h4>\n\n<ul>\n    <li>Scalar multiplication of a matrix is written <tt>s*B</tt> (which is also the way multiplication of numbers is written).</li>\n    <li>It does not matter whether you put spaces around the multiplication sign.</li>\n    <li>Do not write <tt>sA</tt> or <tt>s A</tt>, because Sage will not understand it.</li>\n</ul>\n"}︡
︠5e767e63-7d1d-4b50-9b27-21fda3f5de5es︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
s = 5
s*A
︠025198e1-b938-4928-8aea-972d64717071is︠
%html

<h4>
    Multiplying two matrices
</h4>

<ul>
    <li>Multiplication of matrices is written <tt>A*B</tt> (which is also the way multiplication of numbers is written).</li>
    <li>It does not matter whether you put spaces around the plus sign.</li>
    <li>Do not write <tt>AB</tt> or <tt>A B</tt>, because Sage will not understand it.</li>
</ul>
︡f97c99a6-038c-4263-a249-518905a07c41︡{"html":"\n<h4>\n    Multiplying two matrices\n</h4>\n\n<ul>\n    <li>Multiplication of matrices is written <tt>A*B</tt> (which is also the way multiplication of numbers is written).</li>\n    <li>It does not matter whether you put spaces around the plus sign.</li>\n    <li>Do not write <tt>AB</tt> or <tt>A B</tt>, because Sage will not understand it.</li>\n</ul>\n"}︡
︠cd21fb58-1981-40c8-b840-a6e2dc8c0e87s︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
B = Matrix(QQ,[[2,2,5],[-3,0,3],[1,-2,0]])
A*B
︠1d76ce22-e7e8-40c8-93f5-6de86650a804is︠
%html

<h4>
    Raising a matrix to a power
</h4>

<ul>
    <li>Raising a matrix to a power is written <tt>A^n</tt> (which is also the way raising a number to a power is written).</li>
</ul>
︡a39b541a-2b1a-408f-8460-325812a8efb9︡{"html":"\n<h4>\n    Raising a matrix to a power\n</h4>\n\n<ul>\n    <li>Raising a matrix to a power is written <tt>A^n</tt> (which is also the way raising a number to a power is written).</li>\n</ul>\n"}︡
︠34528e79-6692-4819-a895-b0b9fa01f835s︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
A^3
︠5c3606b6-8b45-4ce5-bd24-c7b0bc223322i︠
%html

<h4>
    Transpose of a matrix
</h4>

<ul>
    <li>The transpose of a matrix is written <tt>A.transpose()</tt>.</li>
</ul>
︡43afc324-174a-4fc2-bb90-1c5f7001a688︡{"html":"\n<h4>\n    Transpose of a matrix\n</h4>\n\n<ul>\n    <li>The transpose of a matrix is written <tt>A.transpose()</tt>.</li>\n</ul>\n"}︡
︠5a539ab2-1001-4e66-b5df-af94abbf1548︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
A.transpose()
︠02fbc9e1-64b2-4e28-b6d0-f4d1224acb15i︠
%html

<h4>
    Inverse of a matrix
</h4>

<ul>
    <li>The inverse of a matrix is written either <tt>A.inverse()</tt> or <tt>A^(-1))</tt>.</li>
    <li>If the matrix is not invertible and you try to find its inverse, Sage will give an error message.</li>
</ul>
︡0c7c0a8a-df83-4310-9319-457ecae248eb︡{"html":"\n<h4>\n    Inverse of a matrix\n</h4>\n\n<ul>\n    <li>The inverse of a matrix is written either <tt>A.inverse()</tt> or <tt>A^(-1))</tt>.</li>\n    <li>If the matrix is not invertible and you try to find its inverse, Sage will give an error message.</li>\n</ul>\n"}︡
︠5f28691a-968d-49d0-a416-464071559741︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
A.inverse()
︠7d4c7a6f-dd34-4feb-a0e8-eee88c9001ec︠
A = Matrix(QQ,[[1,-2,0],[4,1,-1],[0,3,-5]])
A^(-1)
︠52b6a13c-d99b-4af2-9886-2c65c3185bcei︠
%html

<h4>
    Identity matrix
</h4>

<ul>
    <li>The $n \times n$ identity matrix is written <tt>identity_matrix(QQ, n)</tt> or <tt>identity_matrix(RR, n)</tt>, depending upon whether you want fractions or decimals.</li>
</ul>
︡0bd4170e-7a7c-4dda-9763-fc55bca574b7︡{"html":"\n<h4>\n    Identity matrix\n</h4>\n\n<ul>\n    <li>The $n \\times n$ identity matrix is written <tt>identity_matrix(QQ, n)</tt> or <tt>identity_matrix(RR, n)</tt>, depending upon whether you want fractions or decimals.</li>\n</ul>\n"}︡
︠1c91e20f-889f-4cd4-a799-6708084adcae︠
C = identity_matrix(QQ, 5)
C
︠eb001c66-81af-4962-8b59-c4c7a03647f7︠
D = identity_matrix(RR, 5)
D
︠036a2ad1-34f8-479f-9142-2d04405f4962︠









