︠8d2a80ca-1927-496f-9158-4020b2866f27is︠
%html
<h2 style="color:blue">
    Bard - Sage - Plot Slope Fields Demo
</h2
︡fbe295f7-e61d-4f80-b85b-7a6002cae993︡{"html":"<h2 style=\"color:blue\">\n    Bard - Sage - Plot Slope Fields Demo\n</h2\n"}︡
︠f0d45173-b4fc-46ad-a00f-30601943e16ais︠
%html

<h3>
    Using the Sage Interactive Interface
</h3>

<ul>
    <li>There are three options, depending upon whether the differential equation has the form ${dy \over dx} = f(x,y)$ or ${dy \over dx} = f(y)$ or ${dy \over dx} = f(x)$.</li>
    <li>Put the cursor in the code below, and then click on Run (the green square with the triangle in the menu above).</li>
    <li>To change the function, delete the function in the function box, replace it with the function you want, and, with your cursor still in the function box, hit Enter/Return on your keyboard.</li>
    <li>To change the domain of the function, use your mouse to change the endpoints on the slider bars.</li>
    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>
    </ul>



︡65ab2db6-1a36-493d-a2ae-27e1b1c81683︡{"html":"\n<h3>\n    Using the Sage Interactive Interface\n</h3>\n\n<ul>\n    <li>There are three options, depending upon whether the differential equation has the form ${dy \\over dx} = f(x,y)$ or ${dy \\over dx} = f(y)$ or ${dy \\over dx} = f(x)$.</li>\n    <li>Put the cursor in the code below, and then click on Run (the green square with the triangle in the menu above).</li>\n    <li>To change the function, delete the function in the function box, replace it with the function you want, and, with your cursor still in the function box, hit Enter/Return on your keyboard.</li>\n    <li>To change the domain of the function, use your mouse to change the endpoints on the slider bars.</li>\n    <li>Many Sage commands can be found in the menus at the top of the page.  When a menu item is clicked, an example will appear where the cursor was; the example can then be modified to do what you want.</li>\n    </ul>\n\n\n\n"}︡
︠27a586d7-3f1a-48f0-a3f6-2a59180e7a7e︠
x,y = var('x,y')
z = function('z', x)
html(r'''
    <div style="text-align:center">
    $${dy \over dx} = f(x,y)$$
    </div>
    ''')
@interact
def _(
    f = input_box(default = x - y, label = "$f$"),
    a = input_box(default = 0, label = "$a$"),
    b = input_box(default = 1, label = "$b$"),
    xinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$x$-interval"),
    yinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$y$-interval"),
    pm = selector(['Do not show solution curve', 'Show solution curve'], nrows=1, label=" ")
    ):
        x_min, x_max = map(QQ, xinterval);
        y_min, y_max = map(QQ, yinterval);
        r = 0.05
        ic = circle((a, b), r, fill=True, color='red')
        slpfld = plot_slope_field(f, (x, x_min, x_max), (y, y_min, y_max))
        fs = desolve(diff(z, x) == f(x, z), z, ics=[a, b])
        sol = plot(fs, (x, x_min, x_max), ymin = y_min, ymax = y_max, color='red')
        html(r'$$f(x,y) = %s$$'% (latex(f)))
        if pm == 'Do not show solution curve':
            show(slpfld + ic, figsize=10)
        elif pm == 'Show solution curve':
            show(slpfld + sol + ic, figsize=10)

︡016ddb20-1fb2-4228-b3f7-e4ef693b51cb︡{"html":"\n    <div style=\"text-align:center\">\n    $${dy \\over dx} = f(x,y)$$\n    </div>\n    "}︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["a",12,null]],[["b",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["pm",12,null]],[["",12,null]]],"id":"238c1e02-be10-41e3-a527-4dc5fda3236e","controls":[{"control_type":"input-box","default":"x - y","label":"$f$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":0,"label":"$a$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"a","type":null},{"control_type":"input-box","default":1,"label":"$b$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"b","type":null},{"control_type":"range-slider","default":[17,23],"var":"xinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$x$-interval","display_value":true},{"control_type":"range-slider","default":[17,23],"var":"yinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$y$-interval","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["Do not show solution curve","Show solution curve"],"label":" ","nrows":1,"width":null,"var":"pm"}]}}︡
︠5597a7a3-c8eb-4f77-b8ef-7c6653319c77︠
x,y = var('x,y')
z = function('z', x)
html(r'''
    <div style="text-align:center">
    $${dy \over dx} = f(y)$$
    </div>
    ''')
@interact
def _(
    f = input_box(default = 1 - y, label = "$f$"),
    a = input_box(default = 0, label = "$a$"),
    b = input_box(default = 2, label = "$b$"),
    xinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$x$-interval"),
    yinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$y$-interval"),
    pm = selector(['Do not show solution curve', 'Show solution curve'], nrows=1, label=" ")
    ):
        x_min, x_max = map(QQ, xinterval);
        y_min, y_max = map(QQ, yinterval);
        r = 0.05
        ic = circle((a, b), r, fill=True, color='red')
        slpfld = plot_slope_field(f, (x, x_min, x_max), (y, y_min, y_max))
        fs = desolve(diff(z, x) == f(z), z, ics=[a, b])
        sol = plot(fs, (x, x_min, x_max), ymin = y_min, ymax = y_max, color='red')
        html(r'$$f(x,y) = %s$$'% (latex(f)))
        if pm == 'Do not show solution curve':
            show(slpfld + ic, figsize=10)
        elif pm == 'Show solution curve':
            show(slpfld + sol + ic, figsize=10)
︡42dd497e-197c-4942-8ca9-b8a6ff19461c︡{"html":"\n    <div style=\"text-align:center\">\n    $${dy \\over dx} = f(y)$$\n    </div>\n    "}︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["a",12,null]],[["b",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["pm",12,null]],[["",12,null]]],"id":"507bb574-63d1-4529-abdc-bb2a85e1ec1d","controls":[{"control_type":"input-box","default":"-y + 1","label":"$f$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":0,"label":"$a$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"a","type":null},{"control_type":"input-box","default":2,"label":"$b$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"b","type":null},{"control_type":"range-slider","default":[17,23],"var":"xinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$x$-interval","display_value":true},{"control_type":"range-slider","default":[17,23],"var":"yinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$y$-interval","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["Do not show solution curve","Show solution curve"],"label":" ","nrows":1,"width":null,"var":"pm"}]}}︡
︠4f294f18-307d-41e1-bc7d-c615196e7c50︠
x,y = var('x,y')
z = function('z', x)
html(r'''
    <div style="text-align:center">
    $${dy \over dx} = f(x)$$
    </div>
    ''')
@interact
def _(
    f = input_box(default = 1 - x, label = "$f$"),
    a = input_box(default = 0, label = "$a$"),
    b = input_box(default = 1, label = "$b$"),
    xinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$x$-interval"),
    yinterval=range_slider(-20, 20, 1, default = (-3, 3), label = "$y$-interval"),
    pm = selector(['Do not show solution curve', 'Show solution curve'], nrows=1, label=" ")
    ):
        x_min, x_max = map(QQ, xinterval);
        y_min, y_max = map(QQ, yinterval);
        r = 0.05
        ic = circle((a, b), r, fill=True, color='red')
        slpfld = plot_slope_field(f, (x, x_min, x_max), (y, y_min, y_max))
        fs = desolve(diff(z, x) == f(x), z, ics=[a, b])
        sol = plot(fs, (x, x_min, x_max), ymin = y_min, ymax = y_max, color='red')
        html(r'$$f(x,y) = %s$$'% (latex(f)))
        if pm == 'Do not show solution curve':
            show(slpfld + ic, figsize=10)
        elif pm == 'Show solution curve':
            show(slpfld + sol + ic, figsize=10)
︡4110787a-45f2-45a1-98cf-ccd8781f80b5︡{"html":"\n    <div style=\"text-align:center\">\n    $${dy \\over dx} = f(x)$$\n    </div>\n    "}︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["a",12,null]],[["b",12,null]],[["xinterval",12,null]],[["yinterval",12,null]],[["pm",12,null]],[["",12,null]]],"id":"d58579ab-8cb7-4622-971e-316df19ca76a","controls":[{"control_type":"input-box","default":"-x + 1","label":"$f$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":0,"label":"$a$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"a","type":null},{"control_type":"input-box","default":1,"label":"$b$","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"b","type":null},{"control_type":"range-slider","default":[17,23],"var":"xinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$x$-interval","display_value":true},{"control_type":"range-slider","default":[17,23],"var":"yinterval","width":null,"vals":["-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"animate":true,"label":"$y$-interval","display_value":true},{"buttons":false,"control_type":"selector","ncols":null,"button_classes":null,"default":0,"lbls":["Do not show solution curve","Show solution curve"],"label":" ","nrows":1,"width":null,"var":"pm"}]}}︡
︠3edfb283-9b52-4c91-b26d-27f0ae82dcfei︠
︠6a9af5b6-bcdd-41fa-adb2-5479a34ae731︠









